var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('angular2/core');
var common_1 = require('angular2/common');
var moment_ = require('moment');
var moment = moment_['default'] || moment_;
var DatePicker = (function () {
    function DatePicker(cd, viewContainer) {
        cd.valueAccessor = this;
        this.cd = cd;
        this.viewContainer = viewContainer;
        this.el = viewContainer.element.nativeElement;
        this.init();
    }
    DatePicker.prototype.ngAfterViewInit = function () {
        this.initValue();
    };
    DatePicker.prototype.openDatepicker = function () {
        this.isOpened = true;
    };
    DatePicker.prototype.closeDatepicker = function () {
        this.isOpened = false;
    };
    DatePicker.prototype.prevYear = function () {
        this.date.subtract(1, 'Y');
        this.generateCalendar(this.date);
    };
    DatePicker.prototype.prevMonth = function () {
        this.date.subtract(1, 'M');
        this.generateCalendar(this.date);
    };
    DatePicker.prototype.nextYear = function () {
        this.date.add(1, 'Y');
        this.generateCalendar(this.date);
    };
    DatePicker.prototype.nextMonth = function () {
        this.date.add(1, 'M');
        this.generateCalendar(this.date);
    };
    DatePicker.prototype.selectDate = function (e, date) {
        e.preventDefault();
        var selectedDate = moment(date.day + '.' + date.month + '.' + date.year, 'DD.MM.YYYY');
        this.setValue(selectedDate);
        this.closeDatepicker();
    };
    DatePicker.prototype.generateCalendar = function (date) {
        var lastDayOfMonth = date.endOf('month').date();
        var month = date.month();
        var year = date.year();
        var n = 1;
        var firstWeekDay = date.set('date', 1).day();
        this.dateValue = date.format('MMMM YYYY');
        this.days = [];
        for (var i = n; i <= lastDayOfMonth; i += 1) {
            if (i > 0) {
                this.days.push({ day: i, month: month + 1, year: year, enabled: true });
            }
            else {
                this.days.push({ day: null, month: null, year: null, enabled: false });
            }
        }
    };
    DatePicker.prototype.generateDayNames = function () {
        this.dayNames = [];
        var date = this.firstWeekDaySunday === true ? moment('2015-06-07') : moment('2015-06-01');
        for (var i = 0; i < 7; i += 1) {
            this.dayNames.push(date.format('ddd'));
            date.add('1', 'd');
        }
    };
    DatePicker.prototype.initMouseEvents = function () {
        var _this = this;
        var body = document.getElementsByTagName('body')[0];
        body.addEventListener('click', function (e) {
            if (!_this.isOpened || !e.target) {
                return;
            }
            if (_this.el !== e.target && !_this.el.contains(e.target)) {
                _this.closeDatepicker();
            }
        }, false);
    };
    DatePicker.prototype.setValue = function (value) {
        var val = moment(value, this.modelFormat || 'YYYY-MM-DD');
        this.viewValue = val.format(this.viewFormat || 'Do MMMM YYYY');
        this.cd.viewToModelUpdate(val.format(this.modelFormat || 'YYYY-MM-DD'));
    };
    DatePicker.prototype.initValue = function () {
        var _this = this;
        setTimeout(function () {
            if (!_this.initDate) {
                _this.setValue(moment().format(_this.modelFormat || 'YYYY-MM-DD'));
            }
            else {
                _this.setValue(moment(_this.initDate, _this.modelFormat || 'YYYY-MM-DD'));
            }
        });
    };
    DatePicker.prototype.writeValue = function (value) {
        if (!value) {
            return;
        }
        this.setValue(value);
    };
    DatePicker.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    DatePicker.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    DatePicker.prototype.init = function () {
        this.isOpened = false;
        this.date = moment();
        this.firstWeekDaySunday = false;
        this.generateDayNames();
        this.generateCalendar(this.date);
        this.initMouseEvents();
    };
    __decorate([
        core_1.Input('model-format'), 
        __metadata('design:type', String)
    ], DatePicker.prototype, "modelFormat", void 0);
    __decorate([
        core_1.Input('view-format'), 
        __metadata('design:type', String)
    ], DatePicker.prototype, "viewFormat", void 0);
    __decorate([
        core_1.Input('init-date'), 
        __metadata('design:type', String)
    ], DatePicker.prototype, "initDate", void 0);
    DatePicker = __decorate([
        core_1.Component({
            selector: 'datepicker[ngModel]',
            templateUrl: 'node_modules/ng2-datepicker/templates/ng2-datepicker.html',
            styleUrls: ['node_modules/ng2-datepicker/styles/ng2-datepicker.css'],
            directives: [common_1.FORM_DIRECTIVES, common_1.NgIf, common_1.NgFor, common_1.NgClass]
        }), 
        __metadata('design:paramtypes', [common_1.NgModel, core_1.ViewContainerRef])
    ], DatePicker);
    return DatePicker;
})();
exports.DatePicker = DatePicker;
//# sourceMappingURL=ng2-datepicker.js.map